#!/bin/sh
LOG_FILE='/opt/var/log/dibbler/dibbler.log'
#echo -e "\n-- $(date) -- $1\n ------------------------------------------------------\n$(set)" >> $LOG_FILE

log() {
    echo -e "$(date '+%F %H:%M:%S') $*" >> $LOG_FILE
}

case "$1" in
    update)
        log "UPD skipped: $PREFIX1/$PREFIX1LEN via $REMOTE_ADDR dev $IFACE/$IFINDEX ..."
        ;;
    expire)
        log "EXP skipped: $PREFIX1/$PREFIX1LEN via $REMOTE_ADDR dev $IFACE/$IFINDEX ..."
        ;;
    delete)
        ip -6 route del $PREFIX1/$PREFIX1LEN
        ip -6 route del $PREFIX1/$PREFIX1LEN table 200
        ip -6 route del $PREFIX1/$PREFIX1LEN table 201

        log "DEL removed: $PREFIX1/$PREFIX1LEN expired routing entry ..."
        ;;
    add)
        [ -z "$PREFIX1" ] && log "ADD ignored: Prefix is empty ($REMOTE_ADDR) ..." && exit 1

        ip -6 route add $PREFIX1/$PREFIX1LEN via $REMOTE_ADDR dev $IFACE metric 256
        ip -6 route add $PREFIX1/$PREFIX1LEN via $REMOTE_ADDR dev $IFACE metric 1024 table 200
        ip -6 route add $PREFIX1/$PREFIX1LEN via $REMOTE_ADDR dev $IFACE metric 1024 table 201

        echo "ip -6 route del $PREFIX1/$PREFIX1LEN via $REMOTE_ADDR dev $IFACE metric 256"            >> /opt/var/lib/dibbler/undo_routing.sh
        echo "ip -6 route del $PREFIX1/$PREFIX1LEN via $REMOTE_ADDR dev $IFACE metric 256 table 200"  >> /opt/var/lib/dibbler/undo_routing.sh
        echo "ip -6 route del $PREFIX1/$PREFIX1LEN via $REMOTE_ADDR dev $IFACE metric 256 table 201"  >> /opt/var/lib/dibbler/undo_routing.sh

        log "ADD routing: $PREFIX1/$PREFIX1LEN via $REMOTE_ADDR dev $IFACE/$IFINDEX metric 256 ..."
        ;;
    *)
        log "XXX nothing: $1 is unknown ..."
        ;;
esac

exit 0
